// Popis: Umozni skryti konkretnich kesi
// Autor: VasaM
// Licence: CC BY 4.0 CZ

let hiding;
let cachesToHide;


// Vraci true, pokud se ma bod skryt
function hideCache() {
	if (hiding.get() != 'noset') {
		var item = arguments[0][1];

		if (hiding.get() == 'on') {
			if ($.inArray(item.id, cachesToHide.get()) > -1) {
				return true;
			}
		}
		else {
			if ($.inArray(item.id, cachesToHide.get()) == -1) {
				return true;
			}
		}
	}

	return false;
}


// Generuje tabulku skrytych kesi
function hiddenCachesTable() {
	let output = '<table>';
	$.each(cachesToHide.get(), function(index, val) {
		if(val != '') {
			output += '<tr><td>' + val + '</td><td><button onclick="unhideCache(\'' + val + '\')">X</button></td></tr>';
		}
	});
	return output + '</table>';
}


// Prekresli vsechny tlacitka Hide/Unhide
function updateHideButtons(id) {
	function switchTextAndData(elem) {
		switch ($(elem).text()) {
			case 'Hide':
				$(elem).text('Unhide');
				$(elem).data('action', 'Unhide');
				break;

			case 'Unhide':
				$(elem).text('Hide');
				$(elem).data('action', 'Hide');
				break;
		}
	}

	$('.hideThisCacheBtn').each(function() {
		if ($(this).data('id') == id) {
			switchTextAndData(this);
		}
	});
}


// Znovu zobrazi kes s danym id (reakce na tlacitko v nastaveni)
function unhideCache(id) {
	cachesToHide.get().splice( $.inArray(id, cachesToHide.get()), 1 );
	cachesToHide.update();

	updateHideButtons(id);

	addSettings('Hide caches', hiddenCachesTable());
	load_ajax();
}


// Aktualizuje danou kes (reakce na tlacitko Hide/Unhide v popup)
function updateThisCache(elem) {
	let id = $(elem).data('id');

	switch ($(elem).data('action')) {
		case 'Hide':
			cachesToHide.get().push(id);
			break;

		case 'Unhide':
			cachesToHide.get().splice( $.inArray(id, cachesToHide.get()), 1 );
			break;
	}

	cachesToHide.update();

	updateHideButtons(id);

	addSettings('Hide caches', hiddenCachesTable());
	load_ajax();
}



// FIXME
// Vlastni funkce pro vykresleni popupu
getMarkerDetail = function(marker, rootmarker) {
	function prepareContent(data, type) {
    	output = '<div class="point-detailbox' + getStatusStr(data) + getTypeStr(type) + '">';

    	// Pridam tlacitko pro skryti
    	let buttonText = 'Hide';
		if ($.inArray(data.id, cachesToHide.get()) > -1) {
	    	let buttonText = 'Unhide';
    	}
    	output += '<button class="hideThisCacheBtn" data-id="' + data.id + '" data-action="' + buttonText + '"   onclick="updateThisCache(this)">' + buttonText + '</button>';

    	output += '<em class="point-type">' + data.t + '</em>';
 
    	output += '<div class="point-header">';
    	output += '<span class="point-id">' + data.id + '</span>';
    	if (data.url != '') {
    		output += '<a href="' + data.url + '" target="_blank" class="point-link">';
    	}
     
		if (type == "c") {
			output += '<strong class="point-name' + getStatusStr(data) + '">' + data.name + '</strong>';
		}
		else if (type == "w") {
			output += '<span class="point-prefixid">' + data.prefixid + '</span>';
			output += '<strong class="point-name' + getStatusStr(data) + '">' + data.name + '</strong>';
			output += '<span class="point-gcname">' + data.gcname + '</span>';
		}

		if (data.url != '') {
			output += '</a>';
		}
		output += '</div>';

		output += '<span class="point-size">' + data.cachesize + '</span>';
		output += '<span class="point-difficult">' + data.diff + '</span>';
		output += '<span class="point-terrain">' + data.terr + '</span>';
		output += '<span class="point-author">' + data.author + '</span>';
		output += '<span class="point-dthidden">' + formatGGdate(data.dthidden) + '</span>';

		if (data.df > 0) {
			output += '<span class="point-dtfound">' + formatGGdate(data.df) + '</span>';
		}

		if (type == "c" && data.hint != '') {
			output += '<hr>';
			output += '<div class="point-hint">' + data.hint + '</div>';
		}

		if (type == "w" && data.cmt != '') {
			output += '<hr>';
			output += '<div class="point-cmt">' + data.cmt + '</div>';
		}

		if (data.comment != '') {
			output += '<hr>';
			output += '<div class="point-comment">' + data.comment + '</div>';
		}

		output += '<div class="list-buttons">';
		output += '<a href="javascript:touchURL(\'/rest/addlist/' + data.id + '\')" class="add-to-list">Add to list</a>';
		output += '<a href="javascript:touchURL(\'/rest/dellist/' + data.id + '\')" class="del-from-list">Del from list</a>';
		output += '</div>';
		output += '</div>';

		return output;
	}

	if (marker.ggtype == 'c') {
		var aurl = '/ajaxmap/point?' + marker.ggkey;
	}
	else if (marker.ggtype == 'w') {
		var aurl = '/ajaxmap/wpt?' + marker.ggkey;
	};
	
	fetchJSONmany(aurl, function(json){
		TxtZobraz = prepareContent(json, marker.ggtype);
		if (!rootmarker.ggpopup) {
			rootmarker.ggpopup = TxtZobraz;
		}
		else {
			rootmarker.ggpopup = rootmarker.ggpopup + '<p>' + TxtZobraz;
		};
		rootmarker.bindPopup(rootmarker.ggpopup);
		groupCache.fire('click');
	});
}





// Inicializace
function HideCaches_ggm_init() {
	'use strict';


	// Nactu styl
	loadcss('plugin/HideCaches.css');

	// Nactu data
	ggmregister('onload', function() {
		hiding       = Pernament('HideCaches', 'hiding', 'off', 'string');
		cachesToHide = Pernament('HideCaches', 'list',   [],    'stringArray');

		
		// Pridam vypínací tlačítko
		addFilter('Hide caches', 'plugin/HideCaches/hide.png', 'hideCaches_switch');
		$("#hideCaches_switch").setTheSwitch({
			action: hiding.get(),
			onClickOn: function(e)    {hiding.set('on');    load_ajax();},
			onClickNoSet: function(e) {hiding.set('noset'); load_ajax();},
			onClickOff: function(e)   {hiding.set('off');   load_ajax();}
		});

		cachesToHide.set(uniqueElems(cachesToHide.get()));

		addSettings('Hide caches', hiddenCachesTable());
	})


	ggmregister('filterpoint', hideCache);
	ggmregister('filterwpt',   hideCache);
	

	ggmregister('loadbbox', function() {
		updatePointCount();
	});
}